import processing.core.*; 
import processing.xml.*; 

import java.applet.*; 
import java.awt.*; 
import java.awt.image.*; 
import java.awt.event.*; 
import java.io.*; 
import java.net.*; 
import java.text.*; 
import java.util.*; 
import java.util.zip.*; 
import java.util.regex.*; 

public class scale_calc extends PApplet {

Box[] boxes;
PFont fontA;
ArrayList ratios = new ArrayList();
int rows = 24;
int num = 0;
float tet = 2.0f;
public void setup()
{
  smooth();
  background(128);
  for (int i = 0; i < rows; i++){
    num += i+2;
  }
  size(640, 480);
  boxes = new Box[num];
  int columns = 2;
  int k = 0;
  float correction = 0;
  for (int i = 0; i < rows; i++){
    correction = PApplet.parseFloat(width)%PApplet.parseFloat(columns);
    for (int j = 0; j < columns; j++){
      float xposition = width/columns + (correction/PApplet.parseFloat(columns));
      int xpos = round(PApplet.parseFloat(j)*xposition);
      int ypos = i*((height-40)/rows);
      int wid = ceil(PApplet.parseFloat(width)/PApplet.parseFloat(columns) + correction / PApplet.parseFloat(columns));
      int hei = (height-40)/rows;
      float val = PApplet.parseFloat(columns)+PApplet.parseFloat(j);
      val = val / PApplet.parseFloat(columns);
      boxes[k] = new Box(xpos, ypos, wid, hei, 0, val);
      k++;
    }
    columns ++;
  }
  fontA = loadFont("CourierNew36.vlw");
  textFont(fontA, 10);
}

public void draw()
{ 
  for (int i = 0; i < num; i++){
    if(boxes[i].getState() == 1) {
      boxes[i].setState(0); 
    }
    if (boxes[i].mouseOver(mouseX, mouseY)){
      if(boxes[i].getState()!=2)
      {
        boxes[i].setState(1);
      }
    }
    boxes[i].display();
  }
  float tet_offset = 1;
  for (int i = 0; i < tet; i++){
    strokeWeight(2);
    line(((tet_offset - 1.0f)*width), 0, ((tet_offset - 1.0f)*width), (height-50));
    tet_offset*= pow(2.0f, 1.0f/tet);
  }
  /*
  fill(0);
   text(0, height - 40);
   */
  strokeWeight(0);
}


public void mousePressed(){
  for (int i = 0; i < num; i++){
    if(boxes[i].mouseOver(mouseX, mouseY))
    {
      switch (boxes[i].getState())
      {
      case 0:
        boxes[i].setState(2);
        ratios.add(boxes[i].getValue());
        break;
      case 1:
        boxes[i].setState(2);
        ratios.add(boxes[i].getValue());
        break;
      case 2:
        boxes[i].setState(0);
        ratios.remove(ratios.indexOf(boxes[i].getValue()));
        break;
      }
    }
  }
}


public void keyPressed(){
  switch (key){
  case 'r':
    noStroke();
    fill(128);
    rect(0, height-60, width, 60);
    println(ratios);
    Calendar cal = Calendar.getInstance(TimeZone.getTimeZone("America/Los_Angeles"));
    String filename = str(year()) + "_" + str(month()) + "_" + str(day()) + "_" + str(hour()) + "_" + str(minute()) + "_" + str(second());
    println(filename);

    String[] sArray = new String[1];
    sArray[0] = "[";
    for(int i =0; i<ratios.size(); i++){
      sArray[0] = sArray[0] + ratios.get(i).toString();
      if(i < ratios.size() - 1)
      {
        sArray[0] = sArray[0] + ",";
      } 
      else {
        sArray[0] = sArray[0] + "]";
      }
    };

    println(sArray);

    //todo: print array values on bottom of scale...
    fill(0);
    text(sArray[0], 8, height-20);
    saveStrings(filename, sArray);

    break;
  case 'c':
    ratios = new ArrayList();
    for (int i = 0; i < num; i++){
      boxes[i].setState(0);
    }
    break;
  case '+':
    noStroke();
    fill(128);
    rect(0, height-60, width, 60);
    tet++;
    fill(0);
    text(tet, 0, height-40);
    break;
  case '-':
    noStroke();
    fill(128);
    rect(0, height-60, width, 60);
    tet = 2;
    fill(0);
    text(tet, 0, height-40);

    break;
  }
}




class Box
{
  int x;
  int y;
  int w;
  int h;
  int state;
  float value;

  Box(int _x, int _y, int _w, int _h, int _state, float _value)
  {
    x = _x;
    y = _y;
    w = _w;
    h = _h;
    state = _state;
    value = _value;
  }

  public void display()
  {
    rectMode(CORNER);
    stroke(0);
    switch (state)
    {
    case 0:
      fill(255);
      break;
    case 1:
      fill(196, 255, 196);
      break;
    case 2:
      fill(0, 255, 0);
      break;
    }
    rect(x, y, w, h);
  }

  public void click()
  {
    state ++;
    state %= 2;
  }

  public float getValue()
  {
    return value;
  }
  public int getX()
  {
    return x;
  }
  public int getY()
  {
    return y;
  }
  public int getW()
  {
    return w;
  }
  public int getH()
  {
    return h;
  }
  public int getState()
  {
    return state;
  }
  public void setState(int newstate)
  {
    state = newstate;
  }
  public boolean mouseOver(int mX, int mY){
    if (this.getX() < mX && mX < this.getX() + this.getW())
    {
      if (this.getY() < mY && mY < this.getY() + this.getH())
      {
        return true;
      } else {
        return false;
      }
    } else {
      return false;
    }
  }
}


class Textfield {
  int x;
  int y;
  int w;
  int h;
  int state;
  String value;

  Textfield(int _x, int _y, int _w, int _h, int _state, String _value)
  {
    x = _x;
    y = _y;
    w = _w;
    h = _h;
    state = _state;
    value = _value;
  }
  public void display()
  {
    textFont(fontA, 14);
    rectMode(CORNER);
    stroke(0);
    switch (state)
    {
    case 0:
      fill(255);
      break;
    case 1:
      fill(196, 255, 196);
      break;
    case 2:
      fill(0, 255, 0);
      break;
    }
    rect(x, y, w, h);
    fill(0);
    text(value, x, y, w, h);
  }
  public boolean mouseOver(int mX, int mY){
    if (this.getX() < mX && mX < this.getX() + this.getW())
    {
      if (this.getY() < mY && mY < this.getY() + this.getH())
      {
        return true;
      } 
      else {
        return false;
      }
    } 
    else {
      return false;
    }
  }
  public int getX()
  {
    return x;
  }
  public int getY()
  {
    return y;
  }
  public int getW()
  {
    return w;
  }
  public int getH()
  {
    return h;
  }
  public int getState()
  {
    return state;
  }
  public void setState(int newstate)
  {
    state = newstate;
  }
  public void click()
  {
    state ++;
    state %= 1;
  }
  public String getValue()
  {
    return value;
  }
  public void setValue(String newvalue)
  {
    value = newvalue;
  }
  public void keyPressed()
  {
  }
}




  static public void main(String args[]) {
    PApplet.main(new String[] { "--bgcolor=#c0c0c0", "scale_calc" });
  }
}
